/* 1- Escriba un programa que reciba, por lnea de comandos, los datos correspondientes a un pixel (coordenadas y componentes de color RGB). Con la funcin parse_input() parsee las cadenas de entrada. Con la funcin invert_color() invierta los componentes RGB. Observe las dos posibilidades de retornar datos desde una funcin: Por su nombre o pasando una referencia del parmetro.*/
/* Solucin en lenguaje C */

#include <stdio.h>
#include <stdlib.h>

/* Estructura para almacenar las coordenadas */
/* y el color RGB de un pixel. */
typedef struct {
	float x, y; /* Coordenadas */
	unsigned char r,g,b; /* Componentes Red, Green, Blue */
	} t_pixel;

/* Prototipos */
t_pixel parse_input(char*[]);
void invert_color(t_pixel*);

int main(int argc, char* argv[])
{
	t_pixel pixel;
	if (argc != 6)
	{
		printf("Modo de uso: %s <x> <y> <r> <g> <b>\n", argv[0]);
		return 1;
	}
	pixel = parse_input(argv);

	printf("\tCoord pixel: ( %.2f , %.2f )\n", pixel.x, pixel.y);
	printf("\tRGB: ( %d , %d , %d )\n", pixel.r, pixel.g, pixel.b);

	/* El color RGB es invertido */
	invert_color(&pixel);
	printf("\tRGB invert: ( %d , %d , %d )\n", pixel.r, pixel.g, pixel.b);
	return 0;
}

/* El nuevo registro es retornado a travs del nombre de */
/* la funcin. */
t_pixel parse_input(char* argv[])
{
	t_pixel p;
	p.x = atof(argv[1]); /* atof() convierte una cadena de */
	p.y = atof(argv[2]); /* caracteres en un dato 'float' */

	p.r = atoi(argv[3]); /* atoi() convierte una cadena de */
	p.g = atoi(argv[4]); /* caracteres en un dato 'int' */
	p.b = atoi(argv[5]);
	return p;
}

/* Obsrvese el pasaje de una referencia (puntero) para */
/* modificar el parmetro dentro de la funcin. */
void invert_color(t_pixel* pix)
{
	pix->r = 255 - pix->r; /* Equivale a: (*pix).r = ... */
	pix->g = 255 - pix->g; /* Equivale a: (*pix).g = ... */
	pix->b = 255 - pix->b; /* Equivale a: (*pix).b = ... */
}