/* 4- Cree un programa que permita cargar una planilla con datos de alumnos, donde cada uno de ellos disponga de 3 notas y una nota final (promedio de las otras) se inicialice la planilla (todos los registros con padrn igual a 0, lo que significa que ese registro est disponible), luego se lleve a cabo la carga de datos y, por ltimo, se liste la planilla completa. Use la funcin fgets() y limpie el buffer de teclado.*/
/* Solucin en lenguaje C */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#define MAX_ALUMNOS 100

/* Tipo de dato para almacenar tres notas por cada estudiante */
typedef float t_notas[3];

/* Tipo registro para almacenar un alumno */
typedef struct {
	long padron;
	char nombre[50];
	t_notas notas;
	float nota_final;
	} t_alumno;

/* Lista de estudiantes */
typedef t_alumno t_planilla[MAX_ALUMNOS];

/* Dato enumerativo para retornar el "status" de una funcin */
typedef enum {OK, ERROR} t_status;

/* Prototipos */
void inicializar_planilla(t_planilla);
t_status ingresar_nuevo_alumno(t_planilla);
void listar_planilla(t_planilla);
float calcular_nota_final(t_alumno);

/* Programa Principal */
int main()
{
	t_planilla planilla_alumnos;
	t_status status;
	char opcion;

	/* Ntese que, dado que 'planilla_alumnos' es un arreglo, */
	/* se pasa un puntero a la primera posicin (referencia) */
	/* en lugar de hacerse una copia de todos los elementos. */
	inicializar_planilla(planilla_alumnos);

	do {
	status = ingresar_nuevo_alumno(planilla_alumnos);

	if (status == ERROR)
	{
		printf("Se ha producido un error en la carga de datos.\n");
		exit(1);
	}

	printf("Ingresar otro alumno? (s/n): ");
	do {
		scanf("%c", &opcion);
		} while ( toupper(opcion)!='S' && toupper(opcion)!='N' );
	
	} while (toupper(opcion) == 'S');
	printf("\n");

	listar_planilla(planilla_alumnos);
	return 0;
}

/* Inicializacin del listado de estudiantes asignando un */
/* nmero de padrn vaco */
void inicializar_planilla(t_planilla listado)
{
	int i;
	for(i=0; i<MAX_ALUMNOS; i++)
		listado[i].padron = 0;
}

/* Alta de un nuevo estudiante en el listado. Retorna ERROR */
/* si no hubiese espacio suficiente. */
t_status ingresar_nuevo_alumno(t_planilla listado)
{
	int i = 0;

	/* Busca un lugar libre */
	while ((i < MAX_ALUMNOS) && (listado[i].padron != 0))
	i++;
	if (i == MAX_ALUMNOS)
	{
		printf("No hay espacio para un nuevo estudiante.");
		return ERROR;
	}

	printf("Ingrese los datos del nuevo estudiante:\n\n");
	printf("Padrn: ");
	scanf("%ld",&(listado[i].padron));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */
	printf("Nombre: ");
	fgets(listado[i].nombre, 50, stdin);
	if (listado[i].nombre[strlen(listado[i].nombre)-1] == '\n')
		listado[i].nombre[strlen(listado[i].nombre)-1] = '\0';
	else
		while (getchar() != '\n'); /* Limpieza buffer de teclado */
	
	printf("Nota 1: ");
	scanf("%f",&(listado[i].notas[0]));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	printf("Nota 2: ");
	scanf("%f",&(listado[i].notas[1]));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	printf("Nota 3: ");
	scanf("%f",&(listado[i].notas[2]));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	listado[i].nota_final = calcular_nota_final(listado[i]);
	return OK;
}

/* Muestra en pantalla la lista de datos de los estudiantes */
/* registrados. */
void listar_planilla(t_planilla listado)
{
	int i;
	for (i=0; i<MAX_ALUMNOS && listado[i].padron!=0; i++)
	{
	printf("Padrn: %ld\n", listado[i].padron);
	printf("Nombre: %s\n", listado[i].nombre);
	printf("Nota 1: %.2f\n", listado[i].notas[0]);
	printf("Nota 2: %.2f\n", listado[i].notas[1]);
	printf("Nota 3: %.2f\n", listado[i].notas[2]);
	printf("Nota Final: %.2f\n", listado[i].nota_final);
	printf("\n");
	}
}

/* Calcula la nota final como promedio de las tres notas del */
/* estudiante. */
float calcular_nota_final(t_alumno estudiante)
{
	float final = ( estudiante.notas[0] + estudiante.notas[1] + estudiante.notas[2] ) / 3 ;
	return final;
}