{4- Cree un programa que permita cargar una planilla con datos de alumnos, donde cada uno de ellos disponga de 3 notas y una nota final (promedio de las otras) se inicialice la planilla (todos los registros con padrn igual a 0, lo que significa que ese registro est disponible), luego se lleve a cabo la carga de datos y, por ltimo, se liste la planilla completa. Use la funcin fgets() y limpie el buffer de teclado.}
{Solucin en lenguaje Pascal}

PROGRAM cap06_ej04;
CONST MAX_ALUMNOS = 3;

{ Tipo de dato para almacenar tres notas por cada estudiante }
TYPE t_notas = ARRAY[1..3] OF REAL;

{ Tipo registro para almacenar un alumno }
TYPE 	t_alumno = RECORD
	padron: LONGINT;
	nombre: STRING[50];
	notas: t_notas;
	nota_final: REAL;
	END;

{ Lista de estudiantes }
TYPE t_planilla = ARRAY[1..MAX_ALUMNOS] OF t_alumno;

{ Dato enumerativo para retornar el "status" de una funcin }
TYPE t_status = (OK, ERROR);

{ Inicializacin del listado de estudiantes asignando un }
{ nmero de padrn vaco }
PROCEDURE inicializar_planilla(VAR listado: t_planilla);

VAR i: INTEGER;

BEGIN
	FOR i:=1 TO MAX_ALUMNOS DO
	listado[i].padron := 0;
END;

{ Calcula la nota final como promedio de las tres notas del }
{ estudiante. }
FUNCTION calcular_nota_final(estudiante: t_alumno): REAL;

VAR final: REAL;

BEGIN
	final := ( estudiante.notas[1] + estudiante.notas[2] + estudiante.notas[3] ) / 3 ;
	calcular_nota_final := final;
END;

{ Alta de un nuevo estudiante en el listado. Retorna ERROR }
{ si no hubiese espacio suficiente. }
FUNCTION ingresar_nuevo_alumno(VAR listado: t_planilla): t_status;

VAR i: INTEGER;

BEGIN
	i := 0;
	{ Busca un lugar libre }
	WHILE ((i <= MAX_ALUMNOS) AND (listado[i].padron <> 0)) DO
		inc(i); {Equivale a i:=i+1}

	IF (i = MAX_ALUMNOS) THEN
		BEGIN
			WRITELN('No hay espacio para un nuevo estudiante.');
			ingresar_nuevo_alumno := ERROR;
		END
	ELSE
		BEGIN
			WRITELN('Ingrese los datos del nuevo estudiante:');
			WRITELN;

			WRITE('Padrn: ');
			READLN(listado[i].padron);

			WRITE('Nombre: ');
			READLN(listado[i].nombre);

			WRITE('Nota 1: ');
			READLN(listado[i].notas[1]);

			WRITE('Nota 2: ');
			READLN(listado[i].notas[2]);

			WRITE('Nota 3: ');
			READLN(listado[i].notas[3]);

			listado[i].nota_final := calcular_nota_final(listado[i]);
		END;
END;

{ Muestra en pantalla la lista de datos de los estudiantes }
{ registrados. }
PROCEDURE listar_planilla(listado: t_planilla);

VAR i: INTEGER;

BEGIN
	i:=1;
	WHILE (listado[i].padron <> 0) DO
	BEGIN
		WRITELN('Padrn: ', listado[i].padron);
		WRITELN('Nombre: ', listado[i].nombre);
		WRITELN('Nota 1: ', listado[i].notas[1]:4:2);
		WRITELN('Nota 2: ', listado[i].notas[2]:4:2);
		WRITELN('Nota 3: ', listado[i].notas[3]:4:2);
		WRITELN('Nota Final: ', listado[i].nota_final:4:2);
		WRITELN;

	inc(i); {Equivale a i:=i+1}
	END;
END;

VAR 	planilla_alumnos: t_planilla;
	status: t_status;
	opcion: char;

{ Programa Principal }
BEGIN

	{ El pasaje del arreglo es por referencia }
	inicializar_planilla(planilla_alumnos);

	REPEAT

		status := ingresar_nuevo_alumno(planilla_alumnos);
		IF (status = ERROR) THEN
		BEGIN
			WRITELN('Se ha producido un error en la carga de datos.');
			EXIT;
		END;

		WRITE('Ingresar otro alumno? (s/n): ');
		REPEAT
			READLN(opcion);
		UNTIL ( (UPCASE(opcion)='S') OR (UPCASE(opcion)='N') );

	UNTIL (UPCASE(opcion) = 'N');
	WRITELN;

	listar_planilla(planilla_alumnos);
END.