/* 5- Inicialice un tablero para el juego de la batalla naval. El tablero es una matriz bidimensional, donde cada casillero es un registro. La inicializacin debera hacerse en forma aleatoria (tarea para el lector). */
/* Solucin en lenguaje C */

#include <stdio.h>

#define COLS 20
#define FILAS 10

typedef enum {ACORAZADO, CRUCERO, PORTAAVIONES} t_tipo;
typedef enum {FALSE, TRUE} t_bool;

typedef struct {
	t_bool ocupado;
	t_tipo tipo;
	t_bool hundido;
	} t_casillero;

typedef t_casillero t_tablero[FILAS][COLS];

/* Prototipos */
void inicializar_tablero(t_tablero);
void mostrar_tablero(t_tablero);

int main()
{
	t_tablero tablero;
	inicializar_tablero(tablero);
	mostrar_tablero(tablero);
	return 0;
}

void inicializar_tablero(t_tablero tablero)
{
	int i,j;

	for (i=0; i<FILAS; i++)
		for (j=0; j<COLS; j++)
			tablero[i][j].ocupado = FALSE;

	/* 1 acorazado */
	tablero[4][18].ocupado = TRUE;
	tablero[4][18].tipo = ACORAZADO;
	tablero[4][18].hundido = FALSE;
	tablero[5][18].ocupado = TRUE;
	tablero[5][18].tipo = ACORAZADO;
	tablero[5][18].hundido = FALSE;
	tablero[6][18].ocupado = TRUE;
	tablero[6][18].tipo = ACORAZADO;
	tablero[6][18].hundido = FALSE;

	/* 2 cruceros */
	tablero[9][2].ocupado = TRUE;
	tablero[9][2].tipo = CRUCERO;
	tablero[9][2].hundido = FALSE;
	tablero[9][3].ocupado = TRUE;
	tablero[9][3].tipo = CRUCERO;
	tablero[9][3].hundido = FALSE;
	tablero[3][9].ocupado = TRUE;
	tablero[3][9].tipo = CRUCERO;
	tablero[3][9].hundido = FALSE;
	tablero[4][9].ocupado = TRUE;
	tablero[4][9].tipo = CRUCERO;
	tablero[4][9].hundido = FALSE;
	
	/* 3 portaaviones */
	tablero[1][1].ocupado = TRUE;
	tablero[1][1].tipo = PORTAAVIONES;
	tablero[1][1].hundido = FALSE;
	tablero[6][12].ocupado = TRUE;
	tablero[6][12].tipo = PORTAAVIONES;
	tablero[6][12].hundido = FALSE;
	tablero[8][19].ocupado = TRUE;
	tablero[8][19].tipo = PORTAAVIONES;
	tablero[8][19].hundido = FALSE;
}
void mostrar_tablero(t_tablero tablero)
{
	int i,j;

	printf("\t");
	for (i=0; i<COLS+2; i++)
		printf("-");
	printf("\n");

	for (i=0; i<FILAS; i++)
	{
		printf("\t|");
		for (j=0; j<COLS; j++)
		{
			if (!tablero[i][j].ocupado)
				printf(" ");
			else
				switch (tablero[i][j].tipo)
				{
					case ACORAZADO: printf("#");
							break;
					case CRUCERO: printf("X");
							break;
					case PORTAAVIONES: printf("@");
							break;
				}
		}			
		printf("|\n");
	}	

	printf("\t");
	for (i=0; i<COLS+2; i++)
	printf("-");
	printf("\n");
}